/*global $, openFB, app, console, Handlebars */
var LoginView = function (store) {
  'use strict';
  var self = this;
  
  this.initialize = function () {
    var self = this;
    this.el = $('<div/>');
    this.el.on('click', '.facebook-button', this.login);
  };
    
  this.render = function () {
    this.el.html(LoginView.template());
    return this;
  };

  this.login = function () {
    openFB.login(function (response) {
      if (response.status === 'connected') {
        self.getFacebookInfo();
        //app.showAlert("got access token: " + response.authResponse.token, function () {}, "Facebook login succeeded", "Lekka");
      } else {
        app.showAlert(response.error, function () {}, "Facebook login failed", "Oh no");
      }
    }, {scope: 'email,read_stream,publish_actions,publish_stream'});
  };

  this.getFacebookInfo = function () {
    openFB.api({
      path: '/me',
      success: function (data) {
        console.log(JSON.stringify(data));
//        sessionStorage.setItem('fb_id', data.id);
//        sessionStorage.setItem('fb_first_name', data.first_name);
//        sessionStorage.setItem('fb_last_name', data.last_name);
//        sessionStorage.setItem('email', data.email);
        window.localStorage.setItem('fb_id', data.id);
        window.localStorage.setItem('fb_first_name', data.first_name);
        window.localStorage.setItem('fb_last_name', data.last_name);
        window.localStorage.setItem('email', data.email);
        
        var queryString = '?id=' + data.id + '&fName=' + data.first_name + '&lName=' + data.last_name + '&email=' + data.email;
        
        app.executeJsonCall('http://themountaingoat.co.za/webservices/createUser.php' + queryString, function () {
          window.location = '#Today';
        });
      },
      error: app.errorHandler
    });
  };

  this.revoke = function () {
    openFB.revokePermissions(
      function () {
        app.showAlert('Permissions revoked successfully', function () {}, 'Permissions', 'Lekka');
      },
      app.errorHandler
    );
  };

  this.logout = function () {
    openFB.logout(
      function () {
        app.showAlert('Logout successful', function () {}, 'Logout', 'Lekka');
      },
      app.errorHandler
    );
  };
  
  this.initialize();
};
 
LoginView.template = Handlebars.compile($("#login-tpl").html());