/*global $, console, app, Handlebars, google */

var VenueView = function (venue) {
  "use strict";
  // Application Constructor
  this.initialize = function () {
    this.el = $('<div/>');
    this.el.on('click', '#websiteButton', this.openWebsite);
  };
  
  this.render = function () {
    this.el.html(VenueView.template(venue));
    this.showSpecials();
    return this;
  };
  
  this.initializeMap = function () {
    var latitude = venue.gpsLat;
    var longitude = venue.gpsLon;
    var name = venue.venueName;
    try {
      var latLong = new google.maps.LatLng(Number(latitude), Number(longitude));
      var mapOptions = {
          center: latLong,
          zoom: 16,
          mapTypeId: google.maps.MapTypeId.ROADMAP,
          /*streetViewControl:false,*/
          disableDefaultUI: true
        };
      var mapDiv = $('#mapDiv')[0];
      var map = new google.maps.Map(mapDiv, mapOptions);
      
      var marker = new google.maps.Marker({
          position: latLong,
          map: map,
          title: name,
          animation: google.maps.Animation.DROP
        });
    } catch (exception) {
      $('#mapDiv').replaceWith('<span>Cannot load map</span>');
      console.log(exception);
    }
  };
  
  // Renders the specials list.
  this.showSpecials = function () {
    var self = this;
    // Check store first. If there is nothing in there, then fetch from the web.
//    store.getSpecialListByEventId(venue.eventDateID, function (storedSpecials) {
//      if (storedSpecials.length > 0) {
//        self.populateSpecialsTemplate(storedSpecials);
//      } else {
//        app.executeJsonCall('http://themountaingoat.co.za/webservices/listSpecials.php?id=' + venue.id, function (specials) {
//          store.storeSpecialList(specials, venue.eventDateID);
//          self.populateSpecialsTemplate(specials);
//        });
//      }
//    });
    console.log(venue);
    console.log('http://themountaingoat.co.za/webservices/listSpecials.php?id=' + venue.eventID);
      app.executeJsonCall('http://themountaingoat.co.za/webservices/listSpecials.php?id=' + venue.eventID, function (specials) {
        self.populateSpecialsTemplate(specials);
      });
  };
  
  this.populateSpecialsTemplate = function (specials) {
    console.log(specials);
    if (specials.length >= 1) {
      $('#special-list').html(VenueView.specialLiTemplate(specials));
    } else {
      $('#special-list').html(VenueView.noItemTemplate({ entity: "specials" }));
    }
  };
    
//  this.showCallTaxi = function () {
//    app.showAlert("0215551234", function () {}, "Call A Taxi", "Cancel");
//  };
    
  this.openWebsite = function () {
    app.showConfirm("Would you like to go to the following website:\n\r" + venue.website, function (button) {
      if (button == 1) {
        window.open(venue.website, '_system');
      }
    }, "Venue Website", "Okay, Cancel");
  };
  
  this.initialize();
};
 
VenueView.template = Handlebars.compile($("#venue-tpl").html());
VenueView.specialLiTemplate = Handlebars.compile($("#specials-li-tpl").html());
VenueView.noItemTemplate = Handlebars.compile($("#no-item-white-tpl").html());