/*global alert, $, LoginView, TodayView, TomorrowView, TheNextDayView, WalletView, EmployeeView, EventView, VenueView, console, MemoryStore*/
var app = {
  connectionStatus: false,
  
  // Show Alert Function
  showAlert: function (message, callback, title, buttonText) {
    if (navigator.notification) {
      navigator.notification.alert(message, callback, title, buttonText);
    } else {
      alert(title ? (title + ": " + message) : message);
      callback();
    }
  },
  // Show Alert Function
  showConfirm: function (message, callback, title, buttonText) {
    if (navigator.notification) {
      navigator.notification.confirm(message, callback, title, buttonText);
    } else {
      alert(title ? (title + ": " + message) : message);
      callback();
    }
  },
  // Vibrate Function
  vibrate: function (duration) {
    navigator.notification.vibrate(duration);
  },
  // Register Events Function
  registerEvents: function () {
    var self = this;
    $(window).on('hashchange', $.proxy(self.route, self));
    //$(document).on('deviceready', $.proxy(self.onDeviceReady, self));
    document.addEventListener("deviceready", self.onDeviceReady, false);
    $(window).on('unload', $.proxy(self.onUnLoad, self));
    //$(window).on('beforeunload', function () { alert('about to unload'); return "Hello"; });
    $(document).ajaxStart(function () {
      $("#wait").css("display", "block");
    });
    $(document).ajaxComplete(function () {
      $("#wait").css("display", "none");
    });
    $(document).ajaxError(function () {
      $("#wait").css("display", "none");
    });
    $(document).ajaxStop(function () {
      $("#wait").css("display", "none");
    });
//     // Check of browser supports touch events...
//     if (document.documentElement.hasOwnProperty('ontouchstart')) {
//       // ... if yes: register touch event listener to change the "selected" state of the item
//       $('body').on('touchstart', 'a', function(event) {
//         $(event.target).addClass('tappable-active');
//       });
//       $('body').on('touchend', 'a', function(event) {
//         $(event.target).removeClass('tappable-active');
//       });
//     } else {
//       // ... if not: register mouse events instead
//       $('body').on('mousedown', 'a', function(event) {
//         $(event.target).addClass('tappable-active');
//       });
//       $('body').on('mouseup', 'a', function(event) {
//         $(event.target).removeClass('tappable-active');
//       });
//     }
  },
  
  // Defaults to sessionStorage for storing the Facebook token
  initFacebook: function () {
    openFB.init({appId: '754453414577383', tokenStore: window.localStorage});
    //  Uncomment the line below to store the Facebook token in localStorage instead of sessionStorage
    //  openFB.init({appId: '754453414577383', tokenStore: window.localStorage});
    //  openFB.init({appId: '754453414577383', tokenStore: store});
  },
  
  // Route Function
  route: function () {
    var self = this;
    var hash = window.location.hash;

//    if (!hash) {
//      openFB.getLoginStatus(function (data) {
//        if (data.status === 'connected') {
//          if (self.todayPage) {
//            self.slidePage(self.todayPage);
//          } else {
//            self.todayPage = new TodayView(self.store).render();
//            self.slidePage(self.todayPage);
//          }
//        } else {
//          if (self.loginPage) {
//            self.slidePage(self.loginPage);
//          } else {
//            self.loginPage = new LoginView(self.store).render();
//            self.slidePage(self.loginPage);
//          }
//        }
//      });
//      return;
//    }

    if (!hash) {
      if (self.todayPage) {
        self.slidePage(self.todayPage);
      } else {
        self.todayPage = new TodayView(self.store).render();
        self.slidePage(self.todayPage);
      }
      return;
    }

//    if (!hash) {
//      if (self.walletPage) {
//        self.slidePage(self.walletPage);
//      } else {
//        self.walletPage = new WalletView(self.store).render();
//        self.slidePage(self.walletPage);
//      }
//      return;
//    }
    
    // Login
//    if (hash.match(self.loginURL)) {
//      openFB.getLoginStatus(function (data) {
//        if (data.status === 'connected') {
//          window.location = '#Today';
//        } else {
//          self.slidePage(new LoginView().render(), 'right');
//        }
//      });
//    }
    // Today
    if (hash.match(self.todayURL)) {
      var from = 'left';
      if (self.currentPage instanceof TheNextDayView || 
          self.currentPage instanceof WalletView || 
          self.currentPage instanceof LoginView) {
        from = 'right';
      }
      self.slidePage(new TodayView(self.store).render(), from);
    }
    // Tomorrow
    if (hash.match(self.tomorrowURL)) {
      var from = 'left';
      if (self.currentPage instanceof TodayView || 
          self.currentPage instanceof WalletView) {
        from = 'right';
      }
      self.slidePage(new TomorrowView(self.store).render(), from);
    }
    // The Next Day
    if (hash.match(self.nextdayURL)) {
      var from = 'left';
      if (self.currentPage instanceof TomorrowView || 
          self.currentPage instanceof WalletView) {
        from = 'right';
      }
      self.slidePage(new TheNextDayView(self.store).render(), from);
    }
    // Wallet
    if (hash.match(self.walletURL)) {
      var previousScreen = "Today";
      if (self.currentPage instanceof TomorrowView) {
        previousScreen = "Tomorrow";
      } else if (self.currentPage instanceof TheNextDayView) {
        previousScreen = "TheNextDay";
      }
      
      self.slidePage(new WalletView(self.store, {"dateScreen": previousScreen}).render(), 'left');
    }
    // Event
    if (hash.match(self.eventURL)) {
      var match = hash.match(self.eventURL);
      var increaseViewCount = false;
      var from = 'left';
      if (self.currentPage instanceof TodayView || 
          self.currentPage instanceof TomorrowView || 
          self.currentPage instanceof TheNextDayView) {
        from = 'right';
        increaseViewCount = true;
      }
      var eventDate = new Date();
      if (self.currentPage instanceof TomorrowView) {
        eventDate.setDate(eventDate.getDate() + 1);
        self.store.setDateScreen("Tomorrow");
      } else if (self.currentPage instanceof TheNextDayView) {
        eventDate.setDate(eventDate.getDate() + 2);
        self.store.setDateScreen("TheNextDay");
      } else if (self.currentPage instanceof TodayView) {
        self.store.setDateScreen("Today");
      } else if (self.currentPage instanceof VenueView) {
        var dateMatch = hash.match(/\d{4}-\d{1,2}-\d{1,2}/);
        eventDate = dateMatch[0];
      }
      eventDate = app.prettifyDate(eventDate);
      var previousScreen = "Today";
      
      self.store.getDateScreen(function (dateScreen) {
        previousScreen = dateScreen;
      });
      
      self.store.findEventById(Number(match[1]), eventDate, function(event) {
        if (event) {
          console.log('mem');
          event.previousScreen = previousScreen;
          self.slidePage(new EventView(self.store, event, increaseViewCount).render(), from);
        } else {
          console.log('site');
//          app.executeJsonCall('http://themountaingoat.co.za/webservices/eventInfo.php?id=' + match[1] + '&fbID=' + sessionStorage.getItem('fb_id') + '&date=' + eventDate, function (events) {
          var fbId = window.localStorage.getItem('fb_id');
          if (typeof(fbId) == 'undefined' || fbId == null) {
            fbId = 0;
          }
          
          app.executeJsonCall('http://themountaingoat.co.za/webservices/eventInfoNew.php?id=' + match[1] + '&fbID=' + fbId + '&date=' + eventDate, function (events) {
            if (events.length < 1) {
              app.showAlert("Cannot load the event", function () {}, "Error", "Oh no");
            }
            event = events[0];
            console.log(event);
            self.store.storeEvent(event);
            event.previousScreen = previousScreen;
            self.slidePage(new EventView(self.store, event, increaseViewCount).render(), from);
          });
        }
      });
    }
    // Venue
    if (hash.match(self.venueURL)) {
      var match = hash.match(self.venueURL);
      
      self.store.findVenueById(Number(match[1]), function(venue) {
        if (venue) {
          console.log('mem');
          self.slidePage(new VenueView(venue).render(), 'right');
        } else {
          console.log('site');
          console.log(match);
          console.log('http://themountaingoat.co.za/webservices/eventDetails.php?id=' + match[2] + '&eventDateID=' + match[3]);
//          app.executeJsonCall('http://themountaingoat.co.za/webservices/venueInfo.php?id=' + match[1], function (venues) {
          app.executeJsonCall('http://themountaingoat.co.za/webservices/eventDetails.php?id=' + match[2] + '&eventDateID=' + match[3], function (venues) {
//            var dateMatch = hash.match(/\d{4}-\d{1,2}-\d{1,2}/);
            venue = venues[0];
            console.log(venue);
//            venue.id = match[1];
//            venue.eventId = match[2];
//            venue.eventDateID = match[3];
//            venue.eventDate = dateMatch[0];
            self.store.storeVenue(venue);
            self.slidePage(new VenueView(venue).render(), 'right');
          });
        }
      });
    }
  },
  // Slide Page Function
  slidePage: function (page, from) {
    var self = this;
    var to = (from === 'left') ? 'right' : 'left';

    var currentPageDest;

    // If there is no current page (app just started) -> No transition: Position new page in the view port
    if (!self.currentPage) {
      $(page.el).attr('class', 'page stage-center');
      $('body').append(page.el);
      self.currentPage = page;
      return;
    }

    // Cleaning up: remove old pages that were moved out of the viewport
    $('.stage-right, .stage-left').remove();
    $('.stage-left, .stage-right').remove();
    //$('.stage-right, .stage-left').not('.homePage').remove();

    $(page.el).attr('class', 'page stage-' + from);
    currentPageDest = "stage-" + to;

    $('body').append(page.el);

    // Wait until the new page has been added to the DOM...
    setTimeout(function () {
      // Slide out the current page: If new page slides from the right -> slide current page to the left, and vice versa
      $(self.currentPage.el).attr('class', 'page transition ' + currentPageDest);
      // Slide in the new page
      $(page.el).attr('class', 'page stage-center transition');
      
      if (page instanceof VenueView) {
        page.initializeMap();
      }
      
      self.currentPage = page;
    });

  },

  nativePluginResultHandler : function (result) {
    //alert('nativePluginResultHandler - '+result);
    console.log('nativePluginResultHandler: ' + result);
  },

  nativePluginErrorHandler: function (error) {
    //alert('nativePluginErrorHandler - '+error);
    console.log('nativePluginErrorHandler: ' + error);
  },
  
  onDeviceReady: function () {
    var self = this;
    //Set the status bar for iOS
//    StatusBar.styleLightContent();
    //StatusBar.statusBarOverlaysWebView(false);
    //StatusBar.backgroundColorByHexString("#333333");
    //self.showAlert("The device is ready", function () {}, "onDeviceReady", "Lekka");
    //alert("onDeviceReady");
    
    //$(document).on('offline', $.proxy(self.onOffline, self));
    window.addEventListener("offline", self.onOffline, false);
    //$(document).on('online', $.proxy(self.onOnline, self));
    window.addEventListener("online", self.onOnline, false);
    
    //$(document).on('backbutton', $.proxy(self.onBackButton, self));
    document.addEventListener("backbutton", self.onBackButton, false);
    this.gaPlugin = window.plugins.gaPlugin;
    this.gaPlugin.init(nativePluginResultHandler, nativePluginErrorHandler, "UA-XXXXXXXX-X", 10);
  },
  
  onOffline: function () {
    this.showAlert("You are offline. You will not be able to use the app properly until you are connected again.", function () {}, "No internet connection.", "Oh no");
    this.onlineStatus = false;
  },
  
  onOnline: function () {
    this.onlineStatus = true;
  },
  
  onBackButton: function () {
    this.showAlert("Back button was pushed", function () {}, "onBackButton", "Lekka");
    //e.preventDefault();
    //BackButton.override();
    // Should maybe create a second back button even and pop up toast to say that the user should click back again to exit.
    //this.showAlert("This is going to close your app. LOL", function () { navigator.app.exitApp(); }, "Closing app", "Lekka");
  },
  
  onUnLoad: function () {
    this.gaPlugin.exit(nativePluginResultHandler, nativePluginErrorHandler);
  },
  
  trackPage: function (url) {
    this.gaPlugin.trackPage(nativePluginResultHandler, nativePluginErrorHandler, url);
  },
  
  trackEvent: function (q, event, e, r) {
    this.gaPlugin.trackEvent(nativePluginResultHandler, nativePluginErrorHandler, q, event, e, r);
  },
  
  executeJsonCall: function (uri, fnSuccess, fnFail) {
//    $.getJSON(uri, function () {
//      console.log("success");
//    })
    var self = this;
    $.ajax({
      dataType: "json",
      url: uri,
      success: function () {
        console.log("success");
      },
      timeout: 10000
    }).done(fnSuccess)
      .fail(function (jqXHR, textStatus, error) {
        if (jqXHR.status == 0 || jqXHR.status == 105 || textStatus == 'timeout') {
          self.showAlert("We may have a connection issue, please check your connectivity.", function () {}, "Connectivity", "Oh no");
        } else {
          console.error("getJSON failed, status: " + textStatus + ", error: " + error);
          console.log("error");
          if (fnFail) {
            fnFail();
          }
        }
      })
      .always(function () {
        console.log("complete");
      });
  },

  executeAjaxCall: function (uri, verb, inputData, fnSuccess) {
    $.ajax({
      type: verb,
      url: uri,
      data: inputData,
      timeout: 10000
    }).done(fnSuccess)
      .fail(function () {
        console.log("error");
      })
      .always(function () {
        console.log("complete");
      });
  },

  prettifyDate: function (timestamp) {
    var date = new Date(timestamp);
    var year = date.getFullYear().toString();
    var month = (date.getMonth() + 1).toString();
    var day = date.getDate().toString();

    return year + '-' + (month.length >= 2 ? '' : '0') + month + '-' + (day.length >= 2 ? '' : '0') + day;
  },

  prettifyTime: function (timestamp) {
    var time = timestamp.match(/(\d+)(?::(\d\d))/);
    var hours = time[1];
    var minutes = time[2];

    return hours + ':' + minutes;
  },

  prettifyText: function (text) {
    var returnString = text.replace("'", "&apos;");
    return returnString;
  },

  unPrettifyText: function (text) {
    var returnString = text.replace("&apos;", "'");
    return returnString;
  },
  
  trimDate: function (text) {
    var returnString = text.match(/\d{4}-\d{1,2}-\d{1,2}/);
    return returnString;
  },
  
  setupIScroll: function (_this) {
    if (_this.iscroll) {
      console.log('Refresh iScroll');
      _this.iscroll.refresh();
    } else {
      console.log('New iScroll');
      _this.iscroll = new iScroll($('.scroll', _this.el)[0], {hScrollbar: false, vScrollbar: false });
    }
  },
  
  errorHandler: function (error) {
    this.showAlert(error.message, function () {}, "Error", "Oh no");
  },

  // Initialize Function
  initialize: function () {
    var self = this;
    self.detailsURL = /^#employees\/(\d{1,})/;
    self.loginURL = /^#login/;
    self.todayURL = /^#Today/;
    self.tomorrowURL = /^#Tomorrow/;
    self.nextdayURL = /^#TheNextDay/;
    self.walletURL = /^#wallet/;
    self.eventURL = /^#event\/(\d{1,})\/(\d{1,})/;
    self.venueURL = /^#venue\/(\d{1,})\/(\d{1,})\/(\d{1,})/;
    self.registerEvents();
    self.store = new MemoryStore(function () {
      self.route();
    });
    self.initFacebook();
  }
};

app.initialize();

Handlebars.registerHelper('equal', function (lvalue, rvalue, options) {
  if (arguments.length < 3) {
    throw new Error("Handlebars Helper equal needs 2 parameters");
  }
  if (lvalue != rvalue) {
    return options.inverse(this);
  } else {
    return options.fn(this);
  }
});

Handlebars.registerHelper('compare', function (lvalue, operator, rvalue, options) {

    var operators, result;
    
    if (arguments.length < 3) {
        throw new Error("Handlerbars Helper 'compare' needs 2 parameters");
    }
    
    if (options === undefined) {
        options = rvalue;
        rvalue = operator;
        operator = "===";
    }
    
    operators = {
        '==': function (l, r) { return l == r; },
        '===': function (l, r) { return l === r; },
        '!=': function (l, r) { return l != r; },
        '!==': function (l, r) { return l !== r; },
        '<': function (l, r) { return l < r; },
        '>': function (l, r) { return l > r; },
        '<=': function (l, r) { return l <= r; },
        '>=': function (l, r) { return l >= r; },
        'typeof': function (l, r) { return typeof l == r; }
    };
    
    if (!operators[operator]) {
        throw new Error("Handlerbars Helper 'compare' doesn't know the operator " + operator);
    }
    
    result = operators[operator](lvalue, rvalue);
    
    if (result) {
        return options.fn(this);
    } else {
        return options.inverse(this);
    }

});

Handlebars.registerHelper("prettifyDate", function (timestamp) {
  return app.prettifyDate(timestamp);
});

Handlebars.registerHelper("prettifyTime", function (timestamp) {
  return app.prettifyTime(timestamp);
});

Handlebars.registerHelper("prettifyText", function (text) {
  return app.prettifyText(text);
});

Handlebars.registerHelper("trimDate", function (text) {
  return app.trimDate(text);
});